/*
* Dimension definition
*/

#ifndef DIMENSION_H
#define DIMENSION_H

#define NGGMAX 	128   /* maximum grid points in the I->S mapping */
#define NAMAX 	40000 /* maximum number of arclets */
#define NASMAX 	1000  /* maximum number of arclets for study*/
#define IDSIZE	10    /* size in characters of the id of clumps and images*/
#define ZMBOUND   10    /* maximum number of redshift bounded families*/
#define NGMAX 	400	// maximum number of point with the grille command 
#define NMAX 	5000
#define NPMAX 	5000
#define NPZMAX	9	/* maximum number of critical lines in g_cline struct*/
#define NLMAX 	300
#define NIMAX 	50    /* maximum number of families and images per family */
#define NPAMAX 	15
#define NTMAX 	1024
#define NPOINT 	1024  /* Number of contour points in cleanlens mode*/
#define NPARMAX 50	
#define NMCMAX  500	

#define ARRAY_SIZE 2000000

/* zero pour les calculs de dichotomie, amplification infinie, pente nulle */
#define PREC_ZERO 	.00001
/* erreur sur dlsds pour le calcul inverse source->image */
#define PREC_DLSDS 	.00001
/* nombre maximal de points sur une ligne critique tangentielle ou radiale*/
#define NTLINEMAX     250
#define NRLINEMAX     250
#define DMIN	1e-4	// distance minimale de convergence dans le plan image (in arcsec)	
#define NITMAX 	100

#define IDPARAM1 1   // column of the 1st physical parameter in array (cf readBayesModel.c)
#define LINESIZE 1024  // size of a line in bayes.dat  
 
#endif // if DIMENSION_H
