#ifndef FONCTION_H
#define FONCTION_H

#include <stdio.h>
#include "wcs.h"
/*
*  fonction.h
*  kneib jean-paul
*  June 97
*  OMP Toulouse
*/

/*
*  useful function definition
*/
#define	Min(A,B)	((A)<(B)?(A):(B))
#define	Max(A,B)	((A)>(B)?(A):(B))
#define cube(A) 	A*A*A

#define FPRINTF         if (M.verbose > 1) fprintf	/* Full verbose*/
#define NPRINTF         if (M.verbose == 1) fprintf	/* Normal verbose */

/*
 * structures in lenstool
 */

#include "structure.h"

/*
 * functions in lenstool
 */

//#ifdef __cplusplus
//"C" {
//#endif

complex acpx(complex c1,complex c2);
complex acpxflt(complex c1,double f2);
void	  add_pm(double **map,int nx,int ny,double x0,double y0,double m);
void	  amplif();
void	  amplif_mat();
void	  amplif_matinv();
void 	  bicubic_coef(double *y,double *y1,double *y2,double *y12,double d1,double d2,double **c);
void	  e_imageP(struct bitriplet *E,struct point *P, double dlsds, struct bitriplet *A);
void	  e_im_prec(struct bitriplet *E,struct point *P,double dlsds,double prec,int nitermax, struct bitriplet *A);
void	  e_inthere(struct bitriplet *E,struct bitriplet *I,struct point *P,double dlsds, struct bitriplet *res);
double  brent(double ax,double bx,double cx,double (*f)(double),double tol,double *xmin);
double  chi_invim(double **im,struct pixlist pl[],int npl,double dlsds,double **so,double **er,int **imu);
int	  chsigne(struct point A,struct point B,double dlsds);
complex ci05(double x,double y,double eps,double rc,double b0);
complex ci10(double x,double y,double eps,double rc,double b0);
complex ci15(double x,double y,double eps,double rc,double b0);
double  chiz(double z);
void	  classer(struct galaxie image[NAMAX][NIMAX],struct galaxie *cimage);
void	  cleanlens(double zimage);
int	  comparer_pos(struct galaxie A,struct galaxie B);
int	  comparer_tau(struct galaxie A,struct galaxie B);
int	  comparer_zn(struct galaxie A,struct galaxie B);
int	  comparer_z(struct galaxie A,struct galaxie B);
int	  comp_asc(double A,double B);
double  comp_chi_osv(double *vect);
double  comp_chi_osv(double *vect);
void	  comp_dchi_osv(double *vect,double *dvect);
int	  comp_desc(double A,double B);
void	  copyright();
void	  copyTriplet(struct triplet *in, struct triplet *out);
void	  cor_seeing(int n,struct galaxie *image,double seeing);
void	  cor_shear();
complex coscpx(complex c);
complex coshcpx(complex c);
void 	  cp_diffim(double **im1,double **im2,int ni,int nj,double **resim);
double  cp_errdiff(double **im1,double **im2,int ni,int nj,double sigim);
void	  cp_im(double **im,int nx,int ny,double xmin,double xmax,double ymin,double ymax, struct galaxie *source,int nbs);
complex cpx(double re,double im);
void	  crea_filtre(double seeing,double scale,double **filtre,int n);
void	  critic_an();
void	  criticinv(double xmin,double ymin,double xmax,double ymax);
void	  criticnew(int verbose);
complex csiemd(double x,double y,double eps,double b0);
void	  cv_cpsf(double **im,int nx,int ny,double xmin,double xmax,double ymin,double ymax,double seeing);
void	  d_bruiter(double **z,int nx,int ny);
complex dcpx(complex c1,complex c2);
complex dcpxflt(complex c,double f);
double  determinant(struct point *A,struct point *B,struct point *C);
double  d_gauss(double sig,int *idum);
struct ellipse diag(double a,double b,double c);
double  diff_mag(struct galaxie arclet,struct point guess);
double  d_integrer(struct galaxie A,double x,double y,double t,double f,int n);
double  dist2(struct point A,struct point B);
double  distcosmo1(double z);
double  distcosmo2(double z1,double z2);
void	  dist_min();
void	  distor(struct galaxie *image);
double  distprime1(double z);
double  distprime2(double z1,double z2);
double  dist(struct point A, struct point B);
double  dlumcosmo1(double z);
void	  do_itos(double **im,struct pixlist *pl,int npl,double dlsds,double **source, double **erreur,int **imult);
double  d_poisson(double xm,int *idum);
double  d_profil(double x,double y,struct galaxie *gal);
double  d_random(int *idum);
double  dratio(double zl,double zs);
double  dratioprime(double zl,double zs);
double  d_rndschechter(int *idum);
int 	  d_rndtype(int *idum);
double  d_rndz(double zmax,int *idum);
void	  d_seeing(double **im,int nx,int ny,double scale);
double  e_amp(struct point *position,double dlsds);
double  e_amp_gal(struct galaxie *image, double dlsds);
complex ecpx(complex c);
void	  ecrire_r(int nstart,int nstop,struct galaxie liste[NAMAX],char name[20],int printShearFlag);
void	  e_dpl(struct point *gi, double dlsds,struct point *gs);
void	  e_giant(int *ng,struct galaxie giants,struct galaxie *image );
struct point e_grad(struct point *pi);
struct point e_grad_gal(struct galaxie *image);
struct matrix e_grad2(struct point *pi);
struct matrix e_grad2_gal(struct galaxie *image);
struct matrix e_grad2_pot(struct point *pi, int ilens);
void	  e_lensing(struct galaxie source[NAMAX], struct galaxie image[NAMAX][NIMAX]);
int	  e_lens_P(struct point ps,struct point pim[NIMAX],double dlsds);
int	  e_lens(struct galaxie source,struct galaxie image[NIMAX]);
struct ellipse e_mag(struct point *position,double dlsds);
double  e_mass(int icl, double radius);
struct ellipse e_unmag(struct point *position,double dlsds);
struct ellipse e_unmag_gal(struct galaxie *image, double dlsds);
struct point e_zeroamp(struct point A,struct point B,double dlsds);
void	  e_pixel(int np,char *name,struct galaxie *source);
double  e_pot(struct point pi,double dlsds);
double  sersic_dpl(double r,double re, double n, double kappae);
double  sersic_kappa_eps(double r,double re,double n,double theta,double kappas,double eps);
double  sersic_gamma_eps(double r,double re,double n,double theta,double kappas,double eps);
double  err_invim(double **errim,int **imult);
void	  e_tau(int n,struct galaxie gal[NAMAX]);
void	  e_testg(int i,int j,struct bitriplet *Tsol,int ni, struct point *P,double dlsds);
int     e_test_P(struct bitriplet *Tsol,int ni,struct point *ps,struct point image[NIMAX],double dlsds,double err);
int     e_test(struct bitriplet *Tsol,int ni,struct galaxie source,struct galaxie image[NIMAX]);
double  e_time(struct point pi,double dlsds);
void	  e_unlens_fast(int nima,struct galaxie *strima,struct galaxie *source);
void	  e_unlensgrid(double dlsds);
void	  e_unlens(int na,struct galaxie arclet[NAMAX],int *ns,struct galaxie source[NAMAX]);
void	  fftcc_im(double **r_im,double **i_im,double **tfr_im,double **tfi_im,int n,int flag);
void	  fftc_im(double **im,double **tfr_im, double **tfi_im,int n,int flag);
void 	  fft(double *data,int *nn,int ndim,int isign);
void 	  flire(FILE *fichier,char phrase[]);
double  fmin_ell(double dr);
void    fmot(FILE *fichier,char mot[]);
void	  followi(struct point A,struct point B,struct point O,double dlsds);
void	  follow(struct point A,struct point B,struct point O,double dlsds);
struct ellipse formeli(double a,double b,double c);
void 	  frprmn( double *p,int n,double ftol,int *iter,double *fret, double (*func)(double*),void (*dfunc)(double*,double*) );
void	  fr_sq_point(struct point **square,int nbr_lin);
void	  f_shape2(int *istart,struct galaxie *liste,char *name);					
void	  f_shape3(int *istart,struct galaxie *liste,char *name);
void	  f_shape4(int *istart,struct galaxie *liste,char *name);
void	  f_shape_abs(int *istart,struct galaxie *liste,char *name);
void	  f_shape(int *istart,struct galaxie *liste,char *name);
void	  f_shmap(int *istart,struct shear *liste,char *name);
void	  f_source(char *name,struct galaxie *galaxy,int *n);
double  fz_dlsds(double z);
struct galaxie unlens1(struct galaxie arclet,double dlsds);
void    g_amplif(int iampf,double z,char *file);
void    g_ampli(int iamp,int np,double z,char *file);
void    g_curv(int icurv,int np,double z,char *file1, char *file2, char *file3);
void    g_dpl(int idpl,int np,double z,char *filex,char *filey);
void    g_grid(int igrid,int ngrid,double zgrid);
void    g_mass(int imass,int np,double z,char *file);
void    g_poten(int ipoten,int np,double z,char *file);
double  g_profil(double x,double y,struct galaxie gal);
void    g_prop(int nprop,double z);
void    g_radial(int iradial,double zradial,double theta);
void    grid();
void    gridp();
void    g_shearf(int ishear,double z,char *file,int nshearf);
void    g_shear(int ishear,int np,double z,char *file);
void    g_time(int flag,int np,double z,char *file);
int     getNzmlimit();
char*   getParName(int ipx, char* name, int type);
int     getNConstraints();
int     getNParameters();
void	  ic_product(double **r_im,double **i_im,double **r_im2,double **i_im2,double **r_prod,double **i_prod, int nbr_lin,int nbr_col);
complex icpx(complex c);
void	  i_marker(char markfile[], double z);
void	  imtosou(double zimage);
int     inconvexe(struct point P,int np,struct point I[NPOINT]);
int     indexCmp(const char *str1, const char *str2);
int     init_grille(char *infile,int noedit);
int     insidebord(struct point *P,struct triplet *T);
int     inside(struct point *P,struct triplet *T);
void    d_binning(double **im,int *nx,int *ny,int bin);
double  interpol(double xx,double *fxx,double *fyy,double *fy2,int imax);
int     inverse(struct point *P, struct bitriplet *Tsol);
void    isoima(struct ellipse *es,struct ellipse *ampli, struct ellipse *ei);
double  iter(double phi0,double coeur,double ct);
void    keep_cl(double **image,struct pixlist *pl,int *npl);
int     lire(struct galaxie *liste,char *name);
complex lncpx(complex c);
void    local(int type,char localfile[]);
void    mdci05(double x,double y,double eps,double rc,double b0,struct matrix *res);
struct matrix mdci10(double x,double y,double eps,double rc,double b0);
struct matrix mdci15(double x,double y,double eps,double rc,double b0);
void    mdcsiemd(double x,double y,double eps,double b0, struct matrix *res);
struct matrix rotmatrix(struct matrix *P,double theta);
struct matrix sp_grad2(struct point P);
double  min_parabol(double x0,double y0,double x1,double y1,double x2,double y2);
double  min_slope_par(double x0,double y0,double x1,double y1,double x2,double y2);
double  mean(int n, double *array);
double  median(int n, double *array);
double  mode(int n, double *array);
double  ncpx(complex c);
double  nfw_dpl(double r,double rs,double kappas);
double  nfw_gamma(double r,double rs,double kappas);
double  nfw_gamma_eps(double r,double rs,double theta,double kappas,double eps);
double  nfwg_dpl(double r,double rs,double kappas,double alpha);
double  nfwg_gamma(double r,double rs,double kappas,double alpha);
double  nfwg_gamma_eps(double r,double rs,double theta,double kappas,double eps,double alpha);
double  nfwg_kappa(double r,double rs,double kappas,double alpha);
double  nfwg_kappa_eps(double r,double rs,double theta,double kappas,double eps,double alpha);
double  nfw_kappa(double r,double rs,double kappas);
double  nfw_kappa_eps(double r,double rs,double theta,double kappas,double eps);
void    e_nfw_rs2c(double sigma_s, double r_s, double *rhos, double *c, double *M_vir);
void    e_nfw_cmvir2sigrs( double c, double mvir, double *sigma_s, double *r_s );
void    e_nfw_crvir2sigrs( double c, double rvir, double *sigma_s, double *r_s );
void    e_nfw_rsmvir2sig( double rs, double mvir, double *sigma_s );
void    e_nfw_rsrvir2sig( double rs, double rvir, double *sigma_s );
int     o_big_slope();
double  o_chi();
void    o_chi_flux(int i,struct galaxie arclet[NIMAX],double *da,double fluxS);
double  o_chi_pos();
void    o_chires(char *filename);
void    o_dmag(int i,struct galaxie *gali,double *da);
void    o_dpl(int n_im,struct galaxie gali[NIMAX],struct point ps[NIMAX]);
void    o_flux(int n,double *fluxS);
double  o_get_err(int i,int ipx);
double  o_get_lens(int i,int ipx);
double  o_get_lmax(int i,int ipx);
double  o_get_lmin(int i,int ipx);
void    o_global();
double  **o_invim(double zim,double *drim,struct pixlist *plo,int *nplo);
void    o_keep_min(double x1,double x2,double y1,double y2,int ils,int ipx);
void    o_keepz_min(double x1,double x2,double y1,double y2,int iz);
void    o_mag(int n,struct galaxie *arclet);
void    o_mag_m(int n,struct galaxie *arclet);
double  o_min_loc(double y0);
double  o_min_slope(double y0);
double  o_prep();
void    o_prep_mult(int ntmult,struct galaxie *mult);
void    o_print(FILE *OUT,double chi0);
void    o_print_res(double chi0, double evidence);
void    opt_source();
void    o_run1();
void    o_run2();
double  o_run_bayes();
void    o_run();
void    o_run_mc();
void    o_run_mc0();
void    o_runpot1(int flag);
void    o_runpot2();
void    o_runz_mc();
void    o_runz_mc0();
void    o_scale_pot();
void    o_set_err(int i,int ipx,double x);
void    o_set_exc(int i,double excu[NLMAX][NPAMAX],double excd[NLMAX][NPAMAX],int block[NLMAX][NPAMAX]);
void    o_set_ip();
void    o_set_lens_bayes();
void    o_set_lens(int i,int ipx,double x);
void    o_set_lmax(int i,int ipx,double x);
void    o_set_lmin(int i,int ipx,double x);
void    o_set_map();
void    o_set_map_mc();
void    o_set_map_z();
void    o_set_start(int i,int block[NLMAX][NPAMAX]);
void    o_shape(int i,struct galaxie *gali,double *dx,double *sigx2,double *dy,double *sigy2,double *da);
int     o_slope_sp(double *y0);
void    o_stat(int na,struct galaxie arclet[NAMAX]);
double  o_step(double chi0);
int     o_swi_big(int i,int ipx);
void    packzmlimit(char limages[ZMBOUND][IDSIZE], int nimages, char name[IDSIZE]);
complex pcpx(complex c1,complex c2);
complex pcpxflt(complex c,double f);
double  pi05(double x,double y,double eps,double rc,double b0);
double  pi10(double x,double y,double eps,double rc,double b0);
double  pi15(double x,double y,double eps,double rc,double b0);
struct point **al_sq_point(int nbr_lin,int nbr_col);
struct point barycentre(struct triplet *A);
struct point bcentlist(struct point *P,int n);
double  max(int n, double *array);
double  mean(int n, double *array);
double  median(int n, double *array);
struct point milieu(struct point *A,struct point *B);
double  min(int n, double *array);
struct point next(struct point A,struct point B,double dpl,double dlsds);
struct point rotation(struct point P,double theta);
struct point sp_grad(struct point P);
struct point wcenter(struct point A,double wa,struct point B,double wb);
struct point weight_baryc(struct point *P,struct galaxie *multi,int n);
struct polar polxy(struct point xy);
void    pro_arclet(int n, struct galaxie gal[NAMAX]);
void    pro_arclet_m(int n,struct galaxie gal[NAMAX]);
double  psiemd(double x,double y,double eps,double b0);
double  ptau(double x,double y);
void    r_cleanlens(FILE *IN,FILE *OUT);
void    r_cline(FILE *IN,FILE *OUT);
void    r_cosmolimit(FILE *IN,FILE *OUT);
void    r_cosmologie(FILE *IN,FILE *OUT);
double  **readBayesModels(int *nParam, int *nVal);
void    readConstraints();
double  **readimage(struct g_pixel *P);
void    read_lenstable();
int     rescaleCube_1Atom(double *cube, int npar);
void    r_frame(FILE *IN,FILE *OUT);
void    r_grille(FILE *IN,FILE *OUT);
void    r_image(FILE *IN,FILE *OUT);
void    r_large(FILE *IN,FILE *OUT);
void    r_limit(FILE *IN,FILE *OUT,int i);
void    r_observ(FILE *IN,FILE *OUT);
void    r_potentiel(FILE *IN,FILE *OUT,int ilens);
void    r_potfile2(FILE *IN,FILE *OUT,int *ilens);
void    r_potfile(FILE *IN,FILE *OUT,int *ilens);
void    r_runmode(FILE *IN,FILE *OUT);
void    r_source(FILE *IN, FILE *OUT);
void    s_compmag(struct galaxie *gal,int *idum);
void    scale_pot();
complex scpx(complex c1,complex c2);
complex scpxflt(complex c1,double f2);
void	  set_default();
void	  set_dynamics(int i);	// in set_lens.c
void	  set_lens();
void	  set_lens_par(FILE *OUT);
int     set_potfile2(int nplens);
int     set_potfile(int nplens);
void	  set_res_par();
void	  setBayesModel( int iVal, int nParam, int nVal, double **array);// in readBayesModels.c 
double  sgn_darg(complex z1,complex z2);
double  sgn(double x);
double  sig2posS4j(double sigmaArcsec,struct galaxie *multi,struct point ps,int j);
double  sig2posS(double sigmaArcsec,int n);
double  sig2posSj(double sigmaArcsec,struct galaxie *multi,int n,int j);
void	  sig2posSe(struct galaxie *multi,int n, double *sigx2, double *sigy2);
double  signe(struct triplet *T,struct point *P);
complex sincpx(complex c);
complex sinhcpx(complex c);
double  slope(double x0,double y0,double x1,double y1);
void    sortf(int n,double *A,int (*comp)(double,double));
void    sort(int n,struct galaxie *A,int (*comp)(struct galaxie, struct galaxie));
void    s_pixlist(double **image,struct pixlist *pl,int *npl);
void    spline(double *x,double *y,int n,double yp1,double ypn,double *y2);
int     split_image(double **image,int nbr_lin,int nbr_col);
double  sp_pot(struct point P);
void    sp_set(double **map,int nx,int ny,double **map_xx,double **map_yy);
complex sqcpx(complex c);
complex sqrtcpx(complex c);
void    s_sof();
void    s_source();
void    s_sourcebox(struct g_pixel *ps,char *centerfile,double dlsds);
int     splitzmlimit(char name[IDSIZE], char limage[ZMBOUND][IDSIZE]);
void	  st_opt(int mode,struct galaxie *imas,int nima,double *z,double ts[NASMAX][200], double pz[NASMAX][200],double ipz[NASMAX][200],double amp[NASMAX][200], double *kappa,double *gam,double *thetap,double *sumpz,double *tauix, double *tauiy,int jmax,double *zpm,double *nmag);
double  stddev(int n, double *array);
void    study_pg(int type,double seeing,char studyfile[],int fake);
complex tancpx(complex c);
void    tirer(struct galaxie *source);
double  tnfwg_dpl(double xwant,double alphawant);
double  tnfwg_kappa(double xwant,double alphawant);
void    tracepot();
void    e_transform(struct triplet *I,double dlsds, struct triplet *S);
void    interieur(struct triplet *E, struct triplet	*I);
char*   upcase(char * str);
int     unlens_bc(struct point *Ps,struct point Bs,struct galaxie *multi,struct point *multib,int n);
void    updatecut(int i);
void    update_emass(int i);
void    update_epot(int i, double *epot);
int     wc(FILE * file);
void    w_critic();
void    w_gianti(int ngs,char name[20]);
void    w_prop(int nprop,char propfile[]);
void    wr_mass(char *name,double **map_xx,double **map_yy);
void    wr_pot(char *name,double **map);
void    w_sicat(struct galaxie ima[][NIMAX], struct galaxie ss[]);
double  zero(double c1,double c2,double (*f)(double));
double  zero_t(double c1,double c2,double (*f)(double));
void    zonemult();

//#ifdef __cplusplus
//};
//#endif

#endif // if FONCTION_H
