#include <math.h>
#include "lt.h"

#define EPS 1E-6
#define JMAX 22
#define JMAXP JMAX+1
#define K 5

double qromb(double (*func)(double),double a,double b)
{
	double ss,dss;
	double s[JMAXP+1],h[JMAXP+1];
	int j;

	h[1]=1.0;
	for (j=1;j<=JMAX;j++) 
	{
		s[j]=trapzd(func,a,b,j);
		if (j >= K)
		{
			polint(&h[j-K],&s[j-K],K,0.0,&ss,&dss);
			if ( dss*dss < EPS*EPS*ss*ss ) return ss;
		}
		s[j+1]=s[j];
		h[j+1]=0.25*h[j];
	}
	nrerror("Too many steps in routine QROMB");
	return -1;
}

#undef EPS
#undef JMAX
#undef JMAXP
#undef K
