#!/bin/sh
# Call the bayesImage tool, combine all the image*.all files
# and plot then on DS9
#

NAMAX=5000              # Maximum number of images to plot
mult=bayesImage.all     # Name of the combined catalog

[ -e image0.all ] && rm image[0-9]*.all
ok=0 && bayesImage $1 && ok=1

if( [ $ok ] )
then
	[ -e $mult ] && rm $mult
	head -n1 image0.all > $mult
	cat image*.all | grep -v "#" >> $mult
	if( [ $(wc -l $mult | awk '{print $1}') -gt $NAMAX ] )
	then
		echo "WARNING: Too many images... catalog cut at $NAMAX images"
		head -n$((NAMAX+1)) $mult >> a
		mv a $mult
	fi
	pelli $mult red clean 100 point
	rm image[0-9]*.all
fi
