#include<stdio.h>
#include<math.h>
#include<fonction.h>
#include<constant.h>
#include<dimension.h>
#include<structure.h>

/****************************************************************/
/*		nom:		amplif_mat   			*/
/*		auteur:		Ghislain Golse			*/
/*		date:		08/01   			*/
/*		place:		Toulouse			*/
/****************************************************************
 * Calcul de la matrice d'amplification pour chaque image (i,j)  *
 * 
 * Global variables used :
 * - I, multi, amplifi_mat
 * - in e_grad2() : G, lens, lens_table
 * - in distcosmo1() : C
 * - in e_amp() : G, lens, lens_table
 */
void   amplif_mat()
{
	extern struct	g_image	I;
	extern struct	galaxie	multi[NIMAX][NIMAX];
	extern struct	matrix	amplifi_mat[NIMAX][NIMAX];
	
	struct	matrix Mat;
	double	dlsds,A;
	register int i,j;
	int   n;
	
	/* NPRINTF(stderr,"Coucou.......\n"); */
	    
	for(i=0;i<I.n_mult;i++)
	{
		n=I.mult[i];
		dlsds=multi[i][0].dr;
		/* NPRINTF(stderr,"n=%d dlsds=%.3lf\n",n,dlsds);*/
		for(j=0;j<n;j++)
		{
			Mat=e_grad2_gal(&multi[i][j]);
			Mat.a*=dlsds;
			Mat.b*=dlsds;
			Mat.c*=dlsds;
			Mat.d*=dlsds;
			  
			A=e_amp_gal(&multi[i][j],dlsds);
			amplifi_mat[i][j].a=(1.-Mat.c)/A;
			amplifi_mat[i][j].b=-Mat.b/A;
			amplifi_mat[i][j].c=(1.-Mat.a)/A;
			amplifi_mat[i][j].d=-Mat.d/A;
			/* NPRINTF(stderr,"  Ampli[%d][%d]=%.3lf\n ",i,j,1./A); 
			NPRINTF(stderr,"  A[%d][%d].a=%.3lf\n ",i,j,amplifi_mat[i][j].a); 
			NPRINTF(stderr,"  A[%d][%d].b=%.3lf\n ",i,j,amplifi_mat[i][j].b); 
			NPRINTF(stderr,"  A[%d][%d].c=%.3lf\n ",i,j,amplifi_mat[i][j].c); 
			NPRINTF(stderr,"  A[%d][%d].d=%.3lf\n ",i,j,amplifi_mat[i][j].d); */
		};
	};
}
