#include<stdio.h>
#include<string.h>
#include<math.h>
#include<fonction.h>
#include<constant.h>
#include<dimension.h>
#include<structure.h>

/* Create a square seeing filter for convolution in d_seeing() function.
 * filtre[y][x] = ln(2)/(PI*seeing^2) * 2^{ -(x*x+y*y)/seeing^2 }  (!!c'est normal??) 
 */
void crea_filtre(double seeing,double scale,double **filtre,int n)
{
//	char name[30];
	register int i,j;
	double x,y,s,sepix,nd,norm;

	sepix=seeing/scale;   // seeing in pixel
	s=sepix*sepix/log(2.);
	norm=PI*s;  // PI*R^2 in pixels^2
	
	nd=((double) n)/2.;
	
	for(i=0;i<n;i++)
	{
		y=i-nd;
		for(j=0;j<n;j++)
		{
			x=j-nd;		
			filtre[i][j]=exp(-1.*(x*x+y*y)/s)/norm;
		}
	}
//	strcpy(name,"filtre");

	/*
	dim=2;
	size[0]=n;
	size[1]=n;
	strcpy(type,"double");
	strcpy(nature,"real");
	strcpy(mode,"bin");
	sprintf(comments,"filtre seeing");
	wr_ipxs(name,filtre,dim,size,type,mode,nature,comments);
	wrf_fits(name,filtre,n,n,0.,1.,0.,1.);
	*/

}
