#include<stdio.h>
#include<math.h>
#include<fonction.h>
#include<constant.h>
#include<dimension.h>
#include<structure.h>

/****************************************************************/
/*		nom:		e_amp				*/
/*		auteur:		Jean-Paul Kneib			*/
/*		date:		10/02/92			*/
/*		place:		Toulouse			*
 ****************************************************************
 * Return the determinant of the amplification matrix ie the amplification
 * at the position position.
 * 
 * Global variables read : 
 * - in e_grad2() : G, lens, lens_table
 */
double	e_amp(struct point *position,double dlsds)
{
	struct	matrix M;

	M=e_grad2(position);
	M.a*=dlsds;
	M.b*=dlsds;
	M.c*=dlsds;
	M.d*=dlsds;

	return(((1.-M.a)*(1.-M.c)-M.b*M.b));
}

double	e_amp_gal(struct galaxie *image, double dlsds)
{
	struct	matrix M;

	M=e_grad2_gal(image);
	M.a*=dlsds;
	M.b*=dlsds;
	M.c*=dlsds;
	M.d*=dlsds;

	return(((1.-M.a)*(1.-M.c)-M.b*M.b));
}
