#include<stdio.h>
#include<math.h>
#include<fonction.h>
#include<constant.h>
#include<dimension.h>
#include<structure.h>

static struct	point	e_zerodich2(struct point *A,struct point *B,double dlsds);

/****************************************************************/ 
/*		nom:		e_zeroamp			*/
/*		auteur:		Jean-Paul Kneib			*/
/*		date:		10/02/92			*/
/*		place:		Toulouse			*/
/****************************************************************/
/* Return the critical line position between A and B
 * Global variables used :
 * in e_amp() : G, lens, lens_table
 * in e_zerodich2() : G, lens, lens_table
 */
struct	point	e_zeroamp(struct point A,struct point B,double dlsds)
{
	struct point C;
	
	/*order A and B so that amp(A)>amp(B)*/
	if(e_amp(&A,dlsds)>e_amp(&B,dlsds))
	{
		C=A;A=B;B=C;
	};

	return(e_zerodich2(&A,&B,dlsds));
}

/****************************************************************/
/* Return the critical line position between A and B 
 * Global variables used :
 * - in e_amp() : G, lens, lens_table
 */
static struct	point	e_zerodich2(struct point *A,struct point *B,double dlsds)
{
	double	am;
	struct	point	M;
	
	M=milieu(A,B);
	am=e_amp(&M,dlsds);
	if((dist(*A,*B)<PREC_ZERO)||(fabs(am)<PREC_ZERO))
		return(M);
	else if(am*e_amp(A,dlsds)>0)
		/*M and A are on the same side of the critical line (same parity)*/
		return(e_zerodich2(&M,B,dlsds));
	else
		return(e_zerodich2(A,&M,dlsds));
}
