#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<math.h>
#include<fonction.h>
#include<dimension.h>
#include<structure.h>

/****************************************************************/
/*                 Program  : grille				*/
/*                 Version  : 1 mai 1992			*/
/*                 Location : Obs. Toulouse			*/
/*                 Auteur   : jean-paul				*/
/****************************************************************/

int	init_grille(char *infile,int noedit)
{
	extern struct g_mode    M;
	extern struct g_grille	G;
	extern struct g_pot     P;
	extern struct pot       lens[];
	
	int   ils,ilens;
	char	first[150];
#ifndef DEBUG
	char 	command[50];
#endif
	
	FILE	*IN,*OUT;

	set_default();
	
	if( !noedit )
	{

#ifndef DEBUG
		sprintf(command,"vi %s",infile);
		system(command);
#endif

		M.verbose=1;
	}
	
	OUT=fopen("para.out","w");
	
	if( OUT == NULL )
	{
		fprintf(stderr, "ERROR: Opening para.out for writting\n");
		exit(-1);
	}
	
	IN=fopen(infile,"r");
	if( IN != NULL )
	{
		ilens=ils=0;
		do 
		{
			flire(IN,first);
			if( strlen(first) > 0 )	fprintf(OUT,"%s\n",first);
			fflush(OUT);
			
			if (!strcmp(first,"runmode"))
				r_runmode(IN,OUT);
			else if (!strncmp(first,"limit",5))
			{
				r_limit(IN,OUT,ils);
				ils++;
			}
			else if (!strcmp(first,"cleanlens"))
				r_cleanlens(IN,OUT);
			else if (!strncmp(first,"image",5))
				r_image(IN,OUT);
			else if (!strncmp(first,"source",6))
				r_source(IN,OUT);
			else if (!strcmp(first,"cline"))
				r_cline(IN,OUT);
			else if (!strncmp(first,"grille",6) || !strncmp(first,"grid",4))
				r_grille(IN,OUT);
			else if (!strncmp(first,"potent",6))
			{
				// set the name of the clump
				lens[ilens].n[0] = '\0';
				//TODO: better set the O prefix after we completely read the .par file 
				if( ilens < G.no_lens )
					strcpy(lens[ilens].n, "O" );
				
				sprintf(lens[ilens].n, "%s%d", lens[ilens].n, ilens+1);
				
				r_potentiel(IN,OUT,ilens);
				ilens++;
			}
			else if (!strncmp(first,"potfile",7))
			{
				G.nplens=ilens;
				r_potfile(IN,OUT,&ilens);
			}
			else if (!strncmp(first,"potfile2",8))
			{
				G.nplens=ilens;
				r_potfile2(IN,OUT,&ilens);
			}
			else if (!strncmp(first,"grande",6))
				r_large(IN,OUT);
			else if (!strncmp(first,"observ",6))
				r_observ(IN,OUT);
			else if (!strcmp(first,"champ"))
				r_frame(IN,OUT);
			else if (!strncmp(first,"cosmolog",8))
				r_cosmologie(IN,OUT);
			else if (!strcmp(first,"cosmolimit"))
				r_cosmolimit(IN,OUT);
		}
		while(strcmp(first,"fini") !=0 );
	
		fclose(IN);
		fflush(OUT);
		
		// if there is less clumps than written in the .par file
		if( ilens < G.nlens )	
			G.nlens = ilens;
		// if we optimize more clumps than available
		if( G.no_lens > ilens )
			G.no_lens = ilens;
		// if we optimize galaxies from the potfile
		if( G.no_lens > G.nplens) 
			G.nplens = G.no_lens;
		// if the potfile is not defined
		if( P.cut1 == -1 && P.cutkpc1 == -1 )
			G.nplens = G.nlens;
		
		
		set_lens_par(OUT);
		NPRINTF(stderr,"Total number of clumps :%d\n", G.nlens);		
		fclose(OUT);
	}
	else
	{
		fprintf(stderr,"ERROR: file %s not found\n",infile);
		exit(-1);
	}
	
	return(1);
}

