#include<stdio.h>
#include<math.h>
#include<fonction.h>
#include<constant.h>
#include<dimension.h>
#include<structure.h>

/****************************************************************/
/*		nom:		o_dpl				*/
/*		auteur:		Jean-Paul Kneib			*/
/*		date:		10/02/92			*/
/*		place:		Toulouse			*/
/*	Return an array of source position corresponding to the given images
 * Parameters :
 * n_im is the number of arclets for the source
 * gali is an array of arclets
 * ps	is the returned array of sources position. !!!ps[n_im]=ps[0]
 ****************************************************************
 * 
 * Global variables used :
 * - in e_grad_gal() : G, lens, lens_table
 */
void	o_dpl(int n_im,struct galaxie gali[NIMAX],struct point ps[NIMAX])
{
	struct point	Grad;
	register int	i;
	
	for(i=0;i<n_im;i++)
	{
		/* the multiple images z is defined only once by the first image*/
		/* but it has to be well defined for each image in the multiple images file */
		Grad=e_grad_gal(&gali[i]);
		gali[i].Grad=Grad;
	       
		ps[i].x=gali[i].C.x-gali[0].dr*Grad.x;
		ps[i].y=gali[i].C.y-gali[0].dr*Grad.y;
	};
	
	ps[n_im]=ps[0];
	/* printf("dr=%.3lf Ps=%.3lf\n",gali[0].dr,ps[0].x); */

}
