#include<stdio.h>
#include<string.h>
#include<time.h>
#include<math.h>
#include<float.h>
#include<fonction.h>
#include<constant.h>
#include<dimension.h>
#include<structure.h>

/****************************************************************/
/*		nom:		o_print_res			*/
/*		auteur:		Jean-Paul Kneib			*/
/*		date:		10/02/92			*/
/*		place:		Toulouse			*/
/*								*/
/*   Modified : 						*/
/*		EJ (01/09/05)--reference in best.par, index of the objects
 * 		
 ****************************************************************/

void  o_print_res(double chi0, double evidence)
{
	extern struct g_mode    M;
	extern struct g_grille  G;
	extern struct g_image   I;
	extern struct g_frame   F;
	extern struct g_cline   CL;
	extern struct g_source  S;
	extern struct g_large   L;
	extern struct g_observ  O;
	extern struct g_cosmo   C;
	extern struct g_pot     P;
	extern struct pot       lens[NLMAX],lmin[],lmax[],prec[];
	extern struct pot       lmin_s[NLMAX],lmax_s[],prec_s[];
	extern struct z_lim     zlim[];
	extern struct z_lim     zlim_s[];
	extern struct cline     cl[];
	extern struct galaxie   multi[NIMAX][NIMAX];
	extern struct galaxie   arclet[NAMAX];
	extern struct pot       clmin,clmax;
	extern int cblock[NPAMAX];
		
	extern int block[][NPAMAX];
	extern int block_s[][NPAMAX];
	extern int nwarn;
	
	extern double z_dlsds;
	extern double chip,chix,chiy,chis,chil;
	extern double **map_p,**map_axx,**map_ayy;
	int     i,j;
	FILE    *best,*besto;
	double  c,rhos,mvir,d1;
	char    limages[ZMBOUND][IDSIZE];
	time_t  rawtime;
	
	NPRINTF(stderr,"\n*********************************************************\n");
	NPRINTF(stderr,"Chi2:%.3lf\t p:%.3lf s:%.3lf l:%.3lf\n",chi0,chip,chis,chil);
	if( M.inverse == 3 )
		NPRINTF( stderr, "log(Evidence) : %.3lf\n",evidence);
		
	if (lens[0].type!=10)
	{
		for(i=0;i<G.no_lens;i++)
		{
			NPRINTF(stderr,"%s : ", lens[i].n);
			
			d1 = d0 / C.h * distcosmo1(lens[i].z);
			
			/* reset dynamical values */
		
			if ( lens[i].type <= 1 )
				lens[i].sigma=sqrt(lens[i].b0/4./pia_c2);
			else if( lens[i].type == 13 )
				lens[i].sigma=lens[i].b0*1e12*cH0_4piG*C.h/distcosmo1(lens[i].z);
			else
				lens[i].sigma=sqrt(lens[i].b0/6./pia_c2);
			 

			NPRINTF(stderr,"c (%.3lf,%.3lf) e (%.3lf,%.3lf) epot %.3lf\n",
				lens[i].C.x,lens[i].C.y,lens[i].emass,lens[i].theta*RTD,lens[i].epot);
				
			if( lens[i].type == 12 )
			{
				lens[i].rckpc = lens[i].rc * d1;
				e_nfw_rs2c(lens[i].sigma, lens[i].rckpc, &rhos, &c, &mvir);
				NPRINTF(stderr,"c %.2lf rhos %.2leMsol/Mpc3 M200 %.3leMsol\n",c,rhos,mvir);

				NPRINTF(stderr,"rs %.2lf\"(%.2lfkpc) s0 %.2lfkm/s alpha %.3lf\n",
					lens[i].rc,lens[i].rckpc,lens[i].sigma,lens[i].alpha);
					
				if ( lens[i].rcut != DBL_MAX )
				{
					lens[i].rcutkpc = lens[i].rcut * d1;
					NPRINTF(stderr,"R200 %.2lf\"(%.2lfkpc)\n",lens[i].rcut,lens[i].rcutkpc);
				}	
			}
			else
			{
				lens[i].rckpc = lens[i].rc * d1;
				if( lens[i].type == 13 )
				{
					NPRINTF(stderr,"re %.2lf(%.2lfkpc) sigma_e %.2le Msol/kpc^2 n %.3lf\n",
						lens[i].rc,lens[i].rckpc,lens[i].sigma,lens[i].alpha);
				}
				else
				{				
					NPRINTF(stderr,"rc %.2lf(%.2lfkpc) s0 %.2lfkm/s alpha %.3lf\n",
						lens[i].rc,lens[i].rckpc,lens[i].sigma,lens[i].alpha);
				}
				
				if ( lens[i].rcut != DBL_MAX )
				{
					lens[i].rcutkpc = lens[i].rcut * d1; 
					NPRINTF(stderr,"rcut %.2lf(%.2lfkpc)\n",lens[i].rcut,lens[i].rcutkpc);
				}
			}
			
			if (lens[i].type==6 || lens[i].type==89 )
				NPRINTF(stderr,"beta %.3lf\n",lens[i].beta);

			if (lens[i].type==7)
				NPRINTF(stderr,"masse %.3lf 10^12 Msol\n",
					lens[i].b0/4./RTA/GM_c2*(D0/C.h*distcosmo1(lens[i].z)));
		};
	}
	else /* spline mapping */
	{
		sp_set(map_p,G.nx,G.ny,map_axx,map_ayy);
		NPRINTF(stderr,"WRITE: absolute potential map -> pot.best\n");
		wr_pot("pot.best",map_p);
		NPRINTF(stderr,"WRITE: absolute mass map -> mass.best\n");
		wr_mass("mass.best",map_axx,map_ayy);
	};
	
	// Print the optimized redshifts
	for(i=0;i<I.nzlim;i++)
	{
		splitzmlimit(zlim[i].n, limages);
		j = 0;
		while( indexCmp( multi[j][0].n, limages[0] ) ) j++;
		z_dlsds=multi[j][0].dr;
		multi[j][0].z=zero(0.1,100.,fz_dlsds);
		NPRINTF(stderr,"#%s z:%.3lf dlsds:%.3lf \n",
			zlim[i].n,multi[j][0].z,multi[j][0].dr);
	}
	
	NPRINTF(stderr,"***********************************************************\n");
	
	/* ecriture des resultats dans best.par */
	
	best=fopen("best.par","w");
	
	time( &rawtime );
	fprintf(best, asctime( localtime ( &rawtime ) ) );
	if( I.forme >= 0 )
		fprintf(best,"Source plane optimization\n");
	else
		fprintf(best,"Image plane optimization\n");
			
	fprintf(best,"Chi2tot(dof=%d): %.4lf\n",getNConstraints()-getNParameters(), chi0);
	fprintf(best,"Chi2pos: %.3lf\n",chip);
	fprintf(best,"Chi2formex: %.3lf\n",chix);
	fprintf(best,"Chi2formey: %.3lf\n",chiy);
	fprintf(best,"Chi2l: %.3lf\n",chil);
	if( M.inverse == 3 )
		fprintf( best, "log(Evidence) : %.3lf\n",evidence);

	// REDSHIFTS
	for(i=0;i<I.nzlim;i++)
	{
		splitzmlimit( zlim[i].n, limages);
		j = 0;
		while( indexCmp( multi[j][0].n, limages[0] ) ) j++;
		fprintf(best,"#%s z:%.3lf dlsds:%.3lf \n",
			zlim[i].n,multi[j][0].z,multi[j][0].dr);
	};

	fprintf(best,"n_Warning: %d\n",nwarn);
	
	// RUNMODE
	fprintf(best,"runmode\n");
	fprintf(best,"\treference     %d %lf %lf\n",M.iref,M.ref_ra,M.ref_dec);
	fprintf(best,"\timage     %d %s\n",0,M.imafile);
	fprintf(best,"\tsource    %d %s\n",M.source,M.sourfile);
	if(M.study)
		fprintf(best,"\tstudy     %d %s\n",M.study,M.studyfile);
	if(M.seeing)
		fprintf(best,"\timseeing  %.3lf\n",M.seeing);
	if(M.imass)
		fprintf(best,"\tmass      %d %d %.3lf %s\n",M.imass,M.nmass,M.zmass,M.massfile);
	if(M.iampli)
		fprintf(best,"\tampli	   %d %d %.3lf %s\n",M.iampli,M.nampli,M.zampli,M.amplifile);				
	if(M.ishear)
		fprintf(best,"\tshear  %d %d %.3lf %s\n",M.ishear,M.nshear,M.zshear,M.shearfile);
	if(M.ishearf)
		fprintf(best,"\tshearfield  %d %.3lf %s %d\n",M.ishearf,M.zshearf,M.shearffile,M.nshearf);
	if(M.grille)
		fprintf(best,"\tgrille   %d %d %lf\n",M.grille,M.ngrille,M.zgrille);
	if(M.pixel)
		fprintf(best,"\tpixel     %d %d %s\n",M.pixel,M.npixel,M.pixelfile);
		
	fprintf(best,"\tend\n");

	// GRILLE
	fprintf(best,"grille\n");
	fprintf(best,"\tnombre      %d\n",G.ngrid);
	fprintf(best,"\tpolaire     %d\n",0);
	fprintf(best,"\tnlentille   %d\n",G.nlens);
	if( strcmp(CL.algorithm, "MARCHINGSQUARES") )
		fprintf(best,"\tnlens_crit   %d\n",G.nlens_crit);
	fprintf(best,"\tend\n");
	
	// SOURCE
	if(M.image!=0 || M.source!=0)
	{
		fprintf(best,"source\n");
		fprintf(best,"\tz_source     %.3lf\n",S.zs);
		fprintf(best,"\tend\n");
	};
	
	// Write the optimized potentials and limits
	for(i=0;i<G.nlens;i++)
	{
		// POTENTIALS
		fprintf(best,"potentiel %s\n",lens[i].n);
		fprintf(best,"\tprofil     %d\n",lens[i].type);
		fprintf(best,"\tx_centre     %.3lf\n",lens[i].C.x);
		fprintf(best,"\ty_centre     %.3lf\n",lens[i].C.y);
		
		if( lens[i].type!=0 && lens[i].type!=2 && lens[i].type!=7 )
		{
			fprintf(best,"\tellipticite     %.3lf\n",lens[i].emass);
			fprintf(best,"\tangle_pos       %.3lf\n",lens[i].theta*RTD);
		};

		if( lens[i].type == 12 )
		{
			fprintf(best,"\tscale_radius      %.3lf\n",lens[i].rc);
			fprintf(best,"\tscale_radius_kpc  %.3lf\n",lens[i].rckpc);
			
			if( lens[i].rcut != DBL_MAX )
			{
				fprintf(best,"\tvirial_radius      %.3lf\n",lens[i].rcut);
				fprintf(best,"\tvirial_radius_kpc  %.3lf\n",lens[i].rcutkpc);
			}
			
			fprintf(best,"\tv_disp          %.3lf\n",lens[i].sigma);
			
			fprintf(best,"\tconcentration   %.3lf\n",c);
			fprintf(best,"\tvirial_mass     %.3le\n",mvir);
			fprintf(best,"\trhos            %.3le\n",rhos);
			
			fprintf(best,"\talpha           %.3lf\n",lens[i].alpha);				
		}
		else
		{
			if( lens[i].type!=0 && fabs(lens[i].type)!=1 && lens[i].type!=7 )
			{
				fprintf(best,"\tcore_radius         %.3lf\n",lens[i].rc);
				fprintf(best,"\tcore_radius_kpc     %.3lf\n",lens[i].rckpc);
			}
	
			if( lens[i].rcut != DBL_MAX )
			{
				fprintf(best,"\tcut_radius         %.3lf\n",lens[i].rcut);
				fprintf(best,"\tcut_radius_kpc     %.3lf\n",lens[i].rcutkpc);
			}
	
			if( lens[i].type == 13 )
			{
				fprintf(best,"\tsigma_e     %.3le\n",lens[i].sigma);
				fprintf(best,"\tn     %.3lf\n",lens[i].alpha);
			}
			else
				fprintf(best,"\tv_disp     %.3lf\n",lens[i].sigma);
	
			if( lens[i].type==3 || lens[i].type==6 || lens[i].type==84 ||
			    lens[i].type==87 || lens[i].type==88 )
				fprintf(best,"\talpha     %.3lf\n",lens[i].alpha);
	
			if (lens[i].type==6 || lens[i].type==89 )
			{
				fprintf(best,"\tbeta         %.3lf\n",lens[i].beta);
				fprintf(best,"\trc_slope     %.3lf\n",lens[i].rcslope);
			}
	
			if (lens[i].type==7)
				fprintf(best,"\tmasse        %.3lf\n",lens[i].masse);
		}
		
		if (lens[i].mag!= 0)
			fprintf(best,"\tmag		  %.3lf\n",lens[i].mag);
			
		fprintf(best,"\tz_lens     %.3lf\n",lens[i].z);
		fprintf(best,"\tend\n");
	}
	
	// CLINE
	fprintf(best,"cline\n");
	fprintf(best,"\tnplan    %d",CL.nplan);
	for(i=0;i<CL.nplan;i++)
		fprintf(best," %.3lf ",CL.cz[i]);

	fprintf(best,"\n");
	fprintf(best,"\tdmax     %.3lf\n",CL.dmax);
	fprintf(best,"\talgorithm   %s\n",CL.algorithm);
	if( !strcmp(CL.algorithm, "MARCHINGSQUARES") )
	{
		fprintf(best,"\tlimitHigh   %.1lf\n",CL.limitHigh);
		fprintf(best,"\tlimitLow    %.3lf\n",CL.cpas);			
	} else
		fprintf(best,"\tpas      %.3lf\n",CL.cpas);	
	fprintf(best,"\tend\n");
	
	// GRANDE
	fprintf(best,"grande\n");
	fprintf(best,"\tiso         %d %d %.3lf %.3lf %.3lf\n",L.iso,L.nmaxiso,L.scale,L.zonex,L.zoney);
	fprintf(best,"\tname        best\n");
	fprintf(best,"\tprofil      %d %d\n",L.profil,L.pt);
	fprintf(best,"\tcontour     %d %d\n",L.ncourbe,L.pt);
	fprintf(best,"\tlarge_dist  %.3lf\n",L.dlarge);
	fprintf(best,"\tend\n");
	
	// OBSERVATION
	if(M.pixel)
	{
		fprintf(best,"observation\n");
		fprintf(best,"\tseeing       %d %lf\n",O.setseeing,(double)O.seeing);
		fprintf(best,"\tbinning      %d %d\n",O.setbin,O.bin);
		fprintf(best,"\tbruit        %d\n",O.bruit);
		fprintf(best,"\tSKY          %.3lf\n",O.SKY);
		fprintf(best,"\tdispersion   %.3lf\n",sqrt(O.SKY/O.gain));
		fprintf(best,"\tidum         %d\n",O.idum);
		fprintf(best,"\tend\n");
	};
	
	// COSMOLOGY
	fprintf(best,"cosmologie\n");
	fprintf(best,"\tH0        %.3lf\n",C.H0);
	fprintf(best,"\tomegaM    %.3lf\n",C.omegaM);
	fprintf(best,"\tomegaX    %.3lf\n",C.omegaX);
	if( C.kcourb == 0. ) fprintf(best,"\tomegaK    0.\n");
	fprintf(best,"\twX        %.3lf\n",C.wX);
	fprintf(best,"\tend\n");
	
	// CHAMP
	fprintf(best,"champ\n");
	fprintf(best,"\txmin     %.3lf\n",F.xmin);
	fprintf(best,"\txmax     %.3lf\n",F.xmax);
	fprintf(best,"\tymin     %.3lf\n",F.ymin);
	fprintf(best,"\tymax     %.3lf\n",F.ymax);
	fprintf(best,"\tend\n");
	
	
	fprintf(best,"fini\n");
	fclose(best);
	

    /******************************************************************
     *  Write the bestopt.par file
     ******************************************************************/

	if( M.inverse != 3 )
	{
		for(i=0;i<G.no_lens;i++)
		{
			lmin[i]=lmin_s[i];
			lmax[i]=lmax_s[i];
			prec[i]=prec_s[i];
			for(j=0;j<NPAMAX;j++)
				block[i][j]=block_s[i][j];
		};
	
		for(i=0;i<I.nzlim;i++)
			zlim_s[i]=zlim[i];
	}
	
	besto=fopen("bestopt.par","w");
	
	fprintf(besto,"Chi2tot: %.3lf\n",chi0);
	fprintf(besto,"Chi2pos: %.3lf\n",chip);
	fprintf(besto,"Chi2formex: %.3lf\n",chix);
	fprintf(besto,"Chi2formey: %.3lf\n",chiy);
	fprintf(besto,"Chi2l: %.3lf\n",chil);
	if( M.inverse == 3 )
		fprintf( besto, "log(Evidence) : %.3lf\n",evidence);

	// RUNMODE
	fprintf(besto,"runmode\n");
	fprintf(besto,"\treference     %d %lf %lf\n",M.iref,M.ref_ra,M.ref_dec);
	fprintf(besto,"\timage     %d %s\n",0,M.imafile);
	fprintf(besto,"\tsource    %d %s\n",M.source,M.sourfile);
	
	if(M.study)
		fprintf(besto,"\tstudy     %d %s\n",M.study,M.studyfile);	
	if(M.seeing)
		fprintf(besto,"\timseeing  %.3lf\n",M.seeing);
	if( M.inverse != 3 )
		fprintf(besto,"\tinverse   %d %d\n",M.inverse,M.itmax);
	else
		fprintf(besto,"\tinverse   %d %lf %d\n",M.inverse,M.rate,M.itmax );
		
	if(M.imass)
		fprintf(besto,"\tmass      %d %d %.3lf %s\n",M.imass,M.nmass,M.zmass,M.massfile);
	if(M.iampli)
		fprintf(besto,"\tampli	   %d %d %.3lf %s\n",M.iampli,M.nampli,M.zampli,M.amplifile);		
	if(M.ishear)
		fprintf(besto,"\tshear  %d %d %.3lf %s\n",M.ishear,M.nshear,M.zshear,M.shearfile);		
	if(M.ishearf)
		fprintf(besto,"\tshearfield  %d %.3lf %s %d\n",M.ishearf,M.zshearf,M.shearffile,M.nshearf);
	if(M.grille)
		fprintf(besto,"\tgrille   %d %d %lf\n",M.grille,M.ngrille,M.zgrille);
	if(M.pixel)
		fprintf(besto,"\tpixel     %d %d %s\n",M.pixel,M.npixel,M.pixelfile);
		
	fprintf(besto,"\tend\n");
	
	// IMAGE
	fprintf(besto,"image\n");
	fprintf(besto,"\tmultfile    %d %s\n",I.n_mult,I.multfile);
	fprintf(besto,"\tforme       %d\n",I.forme);
	if (I.stat>0)
		fprintf(besto,"\tarcletstat  %d %d %s\n",I.stat,I.statmode,I.arclet);
	if (I.npcl>0)
		for(i=0;i<I.npcl;i++)
			fprintf(besto,"\tcritic    %d %.3lf %.3lf %.3lf %.3lf %.3lf\n",
				cl[i].n,cl[i].C.x,cl[i].C.y,cl[i].phi/DTR,cl[i].dl,cl[i].z);
				
	if (I.nzlim>0)
		for(i=0;i<I.nzlim;i++)
			fprintf(besto,"\tz_m_limit  %d %s %d %.3lf %.3lf %.4lf \n",i+1,
				zlim[i].n,zlim[i].bk,zlim[i].min,zlim[i].max,zlim[i].dderr);
				
	if (I.mult_abs>0)
		fprintf(besto,"\tmult_wcs    %d\n",I.mult_abs);	
		
	if( I.sigposAs != 0 )
		fprintf(besto,"\tsigposArcsec   %lf\n",I.sigposAs);
		
	fprintf(besto,"\tend\n");
	
	// GRILLE
	fprintf(besto,"grille\n");
	fprintf(besto,"\tnombre      %d\n",G.ngrid);
	fprintf(besto,"\tpolaire     %d\n",0);
	fprintf(besto,"\tnlentille   %d\n",G.nlens);
	if( strcmp(CL.algorithm, "MARCHINGSQUARES") )
		fprintf(besto,"\tnlens_crit   %d\n",G.nlens_crit);
		
	fprintf(besto,"\tnlens_opt   %d\n",G.no_lens);
	fprintf(besto,"\tend\n");
	
	// SOURCE
	if(M.image!=0 || M.source!=0)
	{
		fprintf(besto,"source\n");
		fprintf(besto,"\tz_source     %.3lf\n",S.zs);
		fprintf(besto,"\tend\n");
	};
	
	// Write the optimized potentials and limits
	for( i = 0 ; i < G.nplens ; i++ )
	{
		
		
		// POTENTIALS
		fprintf(besto,"potentiel %s\n",lens[i].n);
		fprintf(besto,"\tprofil       %d\n",lens[i].type);
		fprintf(besto,"\tx_centre     %.3lf\n",lens[i].C.x);
		fprintf(besto,"\ty_centre     %.3lf\n",lens[i].C.y);
		if (lens[i].type!=0 && lens[i].type!=2 && lens[i].type!=7)
		{
			fprintf(besto,"\tellipticite     %.3lf\n",lens[i].emass);
			fprintf(besto,"\tangle_pos       %.3lf\n",lens[i].theta*RTD);
		};
		
		if( lens[i].type == 12 )
		{
			fprintf(besto,"\tscale_radius_kpc  %.3lf\n",lens[i].rckpc);
			
			if( lens[i].rcut != DBL_MAX )
				fprintf(besto,"\tvirial_radius_kpc  %.3lf\n",lens[i].rcutkpc);
			
			fprintf(besto,"\tv_disp          %.3lf\n",lens[i].sigma);
			
			fprintf(besto,"\tconcentration   %.3lf\n",c);
			fprintf(besto,"\tvirial_mass     %.3le\n",mvir);
			fprintf(besto,"\trhos            %.3le\n",rhos);
			
			fprintf(besto,"\talpha           %.3lf\n",lens[i].alpha);				
		}
		else
		{
			if (lens[i].type!=0 && fabs(lens[i].type)!=1 && lens[i].type!=7)
				fprintf(besto,"\tcore_radius_kpc     %.3lf\n",lens[i].rckpc );
				
			if ( lens[i].rcut != DBL_MAX )
				fprintf(besto,"\tcut_radius_kpc     %.3lf\n",lens[i].rcutkpc );
			
			if( lens[i].type == 13 )
			{
				fprintf(besto,"\tsigma_e     %.3le\n",lens[i].sigma);
				fprintf(besto,"\tn     %.3lf\n",lens[i].alpha);
			}
			else
				fprintf(besto,"\tv_disp     %.3lf\n",lens[i].sigma);
	
			if( lens[i].type==3 || lens[i].type==6 || lens[i].type==84 ||
			    lens[i].type==87 || lens[i].type==88 )
				fprintf(besto,"\talpha     %.3lf\n",lens[i].alpha);
				
			if (lens[i].type==6 || lens[i].type==89 )
			{
				fprintf(besto,"\tbeta     %.3lf\n",lens[i].beta);
				fprintf(besto,"\trc_slope     %.3lf\n",lens[i].rcslope); 
			}
			
			if (lens[i].type==7)
				fprintf(besto,"\tmasse     %.3lf\n",lens[i].masse);
		}
		
		if (lens[i].mag!= 0)
			fprintf(besto,"\tmag		  %.3lf\n",lens[i].mag);

		fprintf(besto,"\tz_lens     %.4lf\n",lens[i].z);
		fprintf(besto,"\tend\n");
		
		// LIMITS
		d1 = d0 / C.h * distcosmo1(lens[i].z);
		
		fprintf(besto,"limit %s\n",lens[i].n);
		if( block[i][CX] != 0 )
			fprintf(besto,"\tx_centre     %d %.3lf %.3lf %.3lf\n",block[i][CX],
				lmin[i].C.x,lmax[i].C.x,prec[i].C.x);
		if( block[i][CY] != 0 )
			fprintf(besto,"\ty_centre     %d %.3lf %.3lf %.3lf\n",block[i][CY],
				lmin[i].C.y,lmax[i].C.y,prec[i].C.y);
		if (lens[i].type!=0 && lens[i].type!=2 && lens[i].type!=7)
		{
			if( block[i][EPOT] != 0 )
				fprintf(besto,"\tellipticite     %d %.3lf %.3lf %.3lf\n",block[i][EPOT],
					lmin[i].emass,lmax[i].emass,prec[i].epot);
			if( block[i][THETA] != 0 )
				fprintf(besto,"\tangle_pos     %d %.3lf %.3lf %.3lf\n",block[i][THETA],
					lmin[i].theta*RTD,lmax[i].theta*RTD,prec[i].theta*RTD);
		}
		
		if( lens[i].type == 12 )
		{
			
			if( block[i][RC] != 0 )
				fprintf(besto,"\tscale_radius_kpc     %d %.3lf %.3lf %.3lf\n",
					block[i][RC],lmin[i].rc*d1,lmax[i].rc*d1,prec[i].rc*d1 );
			    	
			if( lens[i].rcut != DBL_MAX && block[i][RCUT] != 0 )
				fprintf(besto,"\tvirial_radius_kpc     %d %.3lf %.3lf %.3lf\n",
					block[i][RCUT],lmin[i].rcut*d1,lmax[i].rcut*d1,prec[i].rcut*d1 );
			
			if( block[i][BETA] != 0 )
				fprintf(besto,"\tconcentration    %d %.3lf %.3lf %.3lf\n",
					block[i][BETA],lmin[i].beta,lmax[i].beta,prec[i].beta);

			if( block[i][MASSE] != 0 )
				fprintf(besto,"\tvirial_mass    %d %.3le %.3le %.3le\n",
					block[i][MASSE],lmin[i].masse,lmax[i].masse,prec[i].masse);

				
			if( block[i][PMASS] != 0 )
				fprintf(besto,"\trhos    %d %.3le %.3le %.3le\n",
					block[i][PMASS],lmin[i].pmass,lmax[i].pmass,prec[i].pmass);
		}
		else
		{		
			if( block[i][RC] != 0 )
				fprintf(besto,"\tcore_radius_kpc     %d %.3lf %.3lf %.3lf\n",
					block[i][RC],lmin[i].rc*d1,lmax[i].rc*d1,prec[i].rc*d1 );
			    	
			if( lens[i].rcut != DBL_MAX && block[i][RCUT] != 0 )
				fprintf(besto,"\tcut_radius_kpc     %d %.3lf %.3lf %.3lf\n",
					block[i][RCUT],lmin[i].rcut*d1,lmax[i].rcut*d1,prec[i].rcut*d1 );


			if (lens[i].type==6 || lens[i].type==89 )
				if( block[i][BETA] != 0 )
					fprintf(besto,"\tbeta    %d %.3lf %.3lf %.3lf\n",block[i][BETA],
						lmin[i].beta,lmax[i].beta,prec[i].beta);
	
			if (lens[i].type==7 )
				if( block[i][MASSE] != 0 )
					fprintf(besto,"\tmasse    %d %.3le %.3le %.3le\n",block[i][MASSE],
			        		lmin[i].masse,lmax[i].masse,prec[i].masse);
		}

		if( block[i][B0] != 0 )
		{
			if( lens[i].type == 13 )
				fprintf(besto,"\tsigma_e    %d %.3le %.3le %.3le\n",
					block[i][B0],lmin[i].sigma,lmax[i].sigma,prec[i].sigma);
			else
				fprintf(besto,"\tv_disp    %d %.3lf %.3lf %.3lf\n",
					block[i][B0],lmin[i].sigma,lmax[i].sigma,prec[i].sigma);			 
		}
		
		if( block[i][ALPHA] != 0 )
			fprintf(besto,"\talpha     %d %.3lf %.3lf %.3lf\n",
				block[i][ALPHA],lmin[i].alpha,lmax[i].alpha,prec[i].alpha);

		fprintf(besto,"\tend\n"); 
	}

	// POTFILE
	if( P.mag0 != 0)
	{
		fprintf(besto,"potfile\n");
		fprintf(besto,"\tfilein  %d %s\n", P.ftype, P.potfile );
		fprintf(besto,"\tzlens   %lf\n", P.zlens );
		fprintf(besto,"\ttype    %d\n", P.type );
		fprintf(besto,"\tcorekpc %lf\n", P.corekpc );
		fprintf(besto,"\tmag0    %lf\n", P.mag0 );
		fprintf(besto,"\tsigma   %d %lf %lf\n", P.isigma, P.sigma1, P.sigma2 );
		if( P.cutkpc1 != -1 )
			fprintf(besto,"\tcutkpc  %d %lf %lf\n", P.ircut, P.cutkpc1, P.cutkpc2 );
		else
			fprintf(besto,"\tcut     %d %lf %lf\n", P.ircut, P.cut1, P.cut2 );
			
		fprintf(besto,"\tslope   %d %lf %lf\n", P.islope, P.slope1, P.slope2 );
		fprintf(besto,"\tvdslope %d %lf %lf\n", P.ivdslope, P.vdslope1, P.vdslope2 ); 
		fprintf(besto,"\tend\n");
	}

	// CLINE
	fprintf(besto,"cline\n");
	fprintf(besto,"\tnplan    %d",CL.nplan);
	for(i=0;i<CL.nplan;i++)
		fprintf(besto," %.3lf ",CL.cz[i]);
		
	fprintf(besto,"\n");
	fprintf(besto,"\tdmax     %.3lf\n",CL.dmax);
	fprintf(besto,"\talgorithm   %s\n",CL.algorithm);
	if( !strcmp(CL.algorithm, "MARCHINGSQUARES") )
	{
		fprintf(besto,"\tlimitHigh   %.1lf\n",CL.limitHigh);
		fprintf(besto,"\tlimitLow    %.3lf\n",CL.cpas);			
	} else
		fprintf(besto,"\tpas      %.3lf\n",CL.cpas);
			
	fprintf(besto,"\tend\n");
	
	// GRANDE
	fprintf(besto,"grande\n");
	fprintf(besto,"\tiso         %d %d %.3lf %.3lf %.3lf\n",L.iso,L.nmaxiso,L.scale,L.zonex,L.zoney);
	fprintf(besto,"\tname        best\n");
	fprintf(besto,"\tprofil      %d %d\n",L.profil,L.pt);
	fprintf(besto,"\tcontour     %d %d\n",L.ncourbe,L.pt);
	fprintf(besto,"\tlarge_dist  %.3lf\n",L.dlarge);
	fprintf(besto,"\tend\n");
	
	// OBSERVATIONS
	if(M.pixel)
	{
		fprintf(besto,"observation\n");
		fprintf(besto,"\tseeing       %d %lf\n",O.setseeing,O.seeing);
		fprintf(besto,"\tbinning      %d %d\n",O.setbin,O.bin);
		fprintf(besto,"\tbruit        %d\n",O.bruit);
		fprintf(besto,"\tSKY          %.3lf\n",O.SKY);
		fprintf(besto,"\tdispersion   %.3lf\n",sqrt(O.SKY/O.gain));
		fprintf(besto,"\tidum         %d\n",O.idum);
		fprintf(besto,"\tend\n");
	};
	
	// COSMOLOGY
	fprintf(besto,"cosmologie\n");
	fprintf(besto,"\tH0         %.3lf\n",C.H0);
	fprintf(besto,"\tomegaM     %.3lf\n",C.omegaM);
	fprintf(besto,"\tomegaX     %.3lf\n",C.omegaX);
	if( C.kcourb == 0. ) fprintf(besto,"\tomegaK     0.\n");
	fprintf(besto,"\twX         %.3lf\n",C.wX);
	fprintf(besto,"\tend\n");
	
	// COSMOLIMITS
	fprintf(besto,"cosmolimit\n");
	fprintf(besto,"\tomegaM		%d %.3lf %.3lf\n",
		cblock[OMEGAM],clmin.omegaM,clmax.omegaM);
	fprintf(besto,"\tomegaX		%d %.3lf %.3lf\n",
		cblock[OMEGAX],clmin.omegaX,clmax.omegaX);
	fprintf(besto,"\twX		%d %.3lf %.3lf\n",
		cblock[WX],clmin.wX,clmax.wX);
	fprintf(besto,"\tend\n");
	
	// CHAMP
	fprintf(besto,"champ\n");
	fprintf(besto,"\txmin     %.3lf\n",F.xmin);
	fprintf(besto,"\txmax     %.3lf\n",F.xmax);
	fprintf(besto,"\tymin     %.3lf\n",F.ymin);
	fprintf(besto,"\tymax     %.3lf\n",F.ymax);
	fprintf(besto,"\tend\n");
	
	
	fprintf(besto,"fini\n");
	fclose(besto);
	
	// Write the arclet.best file
	if(I.stat==1)
	{
		for(i=0;i<S.ns;i++)
		{
			z_dlsds=arclet[i].dr;
			arclet[i].z=zero(lens[0].z,100.,fz_dlsds);
		};
		ecrire_r(0,S.ns,arclet,"arclet.best",1);
	}
}
