#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include<fonction.h>
#include<constant.h>
#include<dimension.h>
#include<structure.h>
#include "lt.h"

/*
JPK - OMP - 20 Mai 1995

optimize the source shape of a multiple image not well resolved

*/

double   **im,**tim;
int     nx,ny,nbs;
double   dlsds,xmin,xmax,ymin,ymax;
struct	galaxie	osource[3];


void	opt_source()
{
	extern	struct  g_mode	M;
	extern struct g_observ O;
	extern	struct  g_pixel	imFrame; //PSF
	extern	struct	pot	lens[];
	
	register	int	i,k,l,m,n,o,p; //ii,j,
	//int	nimage;
	//double	err2;
	double	**dim;
	double	**true;
	struct	galaxie	best;
	double	bm=100,merrit,sigim=0.001;
	double	x0,y0,a0,b0,t0,i0;//,in0;
	double	vect[6];//,dvect[6];
	FILE	*out;
	int	nv,niter;
	double	ftol,fret;
	
	
	NPRINTF(stderr,"DO: optimize source of a multiple image not well resolved\n");
	
	/* read source file  and compute the distance ratio -----------------*/
	f_source(M.sourfile,osource,&nbs);
	if (nbs>3) nbs=3;
	
	for(i=0;i<nbs;i++)
		osource[i].dr=dlsds=dratio(lens[0].z,osource[i].z);
	
	NPRINTF(stderr,"nbs:%d dlsds:: %.3lf\n",nbs,dlsds);
	
	/* read observed image -----------------------------------------*/
	NPRINTF(stderr,"READ: image frame\n");
	im=(double **) readimage(&imFrame);
	
	/* define test image with the definition of the image read ----------*/
	nx=imFrame.nx;
	ny=imFrame.ny;
	xmin=imFrame.xmin;
	xmax=imFrame.xmax;
	ymin=imFrame.ymin;
	ymax=imFrame.ymax;
	
	tim = (double **) alloc_square_double(nx,ny);
	dim = (double **) alloc_square_double(nx,ny);
	true = (double **) alloc_square_double(5*nx,5*ny);
	
	cp_im(tim,nx,ny,xmin,xmax,ymin,ymax,osource,nbs);
	cv_cpsf(tim,nx,ny,xmin,xmax,ymin,ymax,O.seeing);
	cp_im(true,5*nx,5*ny,xmin,xmax,ymin,ymax,osource,nbs);
	cp_diffim(tim,im,nx,ny,dim);
	merrit = cp_errdiff(tim,im,nx,ny,sigim);
	wrf_fits("im.fits",im,nx,ny,xmin,xmax,ymin,ymax);
	wrf_fits("tim.fits",tim,nx,ny,xmin,xmax,ymin,ymax);
	wrf_fits("true.fits",true,5*nx,5*ny,xmin,xmax,ymin,ymax);
	wrf_fits("dim.fits",dim,nx,ny,xmin,xmax,ymin,ymax);
	
	
	vect[0]=osource[0].C.x;
	vect[1]=osource[0].C.y;
	vect[2]=osource[0].E.a;
	vect[3]=osource[0].E.b;
	vect[4]=osource[0].E.theta;
	vect[5]= osource[0].I0;
	NPRINTF(stderr,"m: %.4lf %.4lf %.4lf %.4lf %.1lf %.3lf %.4lf %.3lf \n",
		vect[0],vect[1],vect[2],vect[3],vect[4]*RTD,osource[0].z,vect[5],merrit);
	
	x0=osource[0].C.x;
	y0=osource[0].C.y;
	a0=osource[0].E.a;
	b0=osource[0].E.b;
	t0=osource[0].E.theta;
	i0=osource[0].I0;
	
	k=l=m=n=o=p=0;
	/*
	for(k=-1;k<2;k++)
	for(l=-1;l<2;l++)
	*/
	for(m=-1;m<2;m++)
		for(n=-1;n<2;n++)
			for(o=-1;o<2;o++)
				for(p=-1;p<2;p++)
				{
					vect[0]=x0+k*0.001;
					vect[1]=y0+l*0.001;
					vect[2]=a0*(1+m*0.1);
					vect[3]=b0*(1+n*0.1);
					vect[4]=t0+p*0.1;
					vect[5]=i0*(1+o*0.05);
					
					nv=6;
					ftol=0.01;
					fret=comp_chi_osv(vect);
					if (fret<5.)
					{
						frprmn(vect,nv,ftol,&niter,&fret,comp_chi_osv,comp_dchi_osv);
						NPRINTF(stderr,"niter:%d fret:%.3lf\n",niter,fret);
					}
					
					NPRINTF(stderr,"m: %.4lf %.4lf %.4lf %.4lf %.1lf %.3lf %.4lf %.3lf \n",
						vect[0],vect[1],vect[2],vect[3],vect[4]*RTD,osource[0].z,vect[5],fret);
					
					if (fret<bm)
					{
						best.C.x=vect[0];
						best.C.y=vect[1];
						best.E.a=vect[2];
						best.E.b=vect[3];
						best.E.theta=vect[4];
						best.I0=vect[5];
						bm=fret;
					}
				}
	
	out=fopen("best.dat","w");
	fprintf(out,"1 %.4lf %.4lf  %.4lf %.4lf %.1lf %.3lf %.2lf %.3lf\n",
			best.C.x,best.C.y,
			best.E.a,best.E.b,best.E.theta*RTD,osource[0].z,best.I0,bm);
	NPRINTF(stderr,"1 %.4lf %.4lf  %.4lf %.4lf %.1lf %.3lf %.2lf %.3lf\n",
			best.C.x,best.C.y,
			best.E.a,best.E.b,best.E.theta*RTD,osource[0].z,best.I0,bm);
	fclose(out);
	
	osource[0]=best;
	
	cp_im(tim,nx,ny,xmin,xmax,ymin,ymax,osource,nbs);
	cv_cpsf(tim,nx,ny,xmin,xmax,ymin,ymax,O.seeing);
	
	cp_im(true,5*nx,5*ny,xmin,xmax,ymin,ymax,osource,nbs);
	
	/* compute  differnce of test and observed image  --------------*/
	cp_diffim(tim,im,nx,ny,dim);
	 
	wrf_fits("im.fits",im,nx,ny,xmin,xmax,ymin,ymax);
	wrf_fits("tim.fits",tim,nx,ny,xmin,xmax,ymin,ymax);
	wrf_fits("true.fits",true,5*nx,5*ny,xmin,xmax,ymin,ymax);
	wrf_fits("dim.fits",dim,nx,ny,xmin,xmax,ymin,ymax);
	
	free_square_double(im,nx);
	free_square_double(tim,nx);
	free_square_double(dim,nx);
	free_square_double(true,5*nx);
	

}

