#include<stdio.h>
#include<string.h>
#include<stdlib.h>
#include<math.h>
#include<fonction.h>
#include<constant.h>
#include<dimension.h>
#include<structure.h>

/****************************************************************/
/*                 Program  : r_image				*/
/*                 Version  : 1 mai 1992			*/
/*                 Location : Obs. Toulouse			*/
/*                 Auteur   : jean-paul				*/
/****************************************************************/

static void scanzmlimit(char *third, int *opt, char *name, int *bk, double *min, double *max, double *prec);

void r_image(FILE *IN,FILE *OUT)
{
	extern struct g_mode   M;
	extern struct g_image  I;
	extern struct MCarlo   mc;
	extern struct z_lim    zlim[];
	extern struct cline    cl[];
	char   second[20],third[50];
	int    ii,j=0,k=0;
	double x;

	fmot(IN,second);
	while(strcmp(second,"end"))
	{
		flire(IN,third);
		
		if (!strcmp(second,"arcletstat"))
		{
			sscanf(third,"%d%d%s",&I.stat,&I.statmode,I.arclet);
			
			fprintf(OUT,"\t%s\t%d %d %s\n",
				second,I.stat,I.statmode,I.arclet);
		}
		else if( !strcmp(second,"sigell"))
		{
			sscanf(third,"%lf %lf",&I.sigell,&I.dsigell);
			fprintf(OUT,"\t%s\t%lf ", second, I.sigell);
			if( I.dsigell != -1. )
				fprintf(OUT,"%lf", I.dsigell);
			fprintf(OUT,"\n");
		}
		else if (!strcmp(second,"shearmap"))
		{
			sscanf(third,"%d%lf%s",&I.shmap,&I.zsh,I.shfile);
			
			fprintf(OUT,"\t%s\t%d %lf %s\n",second,I.shmap,I.zsh,I.shfile);
		}
		else if (!strcmp(second,"z_arclet"))
		{
			sscanf(third,"%s%lf",I.nza,&I.zarclet);
			
			fprintf(OUT,"\t%s\t%s %lf\n",
				second,I.nza,I.zarclet);
		}
		else if (!strcmp(second,"multfile"))
		{
			sscanf(third,"%d%s",&I.n_mult,I.multfile); 
			fprintf(OUT,"\t%s\t%d %s\n",second,I.n_mult,I.multfile);
		}
		else if (!strcmp(second,"mult_wcs"))
		{
			sscanf(third,"%d",&I.mult_abs); 
			fprintf(OUT,"\t%s\t%d\n",second,I.mult_abs);
		}
		else if (!strcmp(second,"sigpos"))
		{
			sscanf(third,"%lf",&x); 
			fprintf(OUT,"\t%s\t\t%lf\n",second,x);
			I.sigposAs=sqrt(x);
		}
		else if (!strcmp(second,"sigposArcsec"))
		{
			sscanf(third,"%lf %lf",&I.sigposAs,&I.dsigposAs); 
			fprintf(OUT,"\t%s\t\t%lf ",second,I.sigposAs);
			if( I.dsigposAs != -1. )
				fprintf(OUT,"%lf",I.dsigposAs);
			fprintf(OUT,"\n");
		}
		else if (!strcmp(second,"sigamp"))
		{
			sscanf(third,"%lf",&x); 
			fprintf(OUT,"\t%s\t\t%lf\n",second,x);
			I.sig2amp=x*x;
		}
		else if (!strcmp(second,"Dmag"))
		{
			sscanf(third,"%lf",&I.Dmag); 
			
			fprintf(OUT,"\t%s\t\t%lf\n",second,I.Dmag);
		}
		else if (!strcmp(second,"forme"))
		{
			sscanf(third,"%d",&I.forme);
			
			fprintf(OUT,"\t%s\t\t%d\n",second,I.forme);
		}
		else if (!strcmp(second,"n_MonteCarlo"))
		{
			sscanf(third,"%d",&mc.n_MonteCarlo);
			
			fprintf(OUT,"\t%s\t\t%d\n",second,mc.n_MonteCarlo);
		}
		else if (!strcmp(second,"optMC"))
		{
			sscanf(third,"%d",&mc.optMC);
			
			fprintf(OUT,"\t%s\t\t%d\n",second,mc.optMC);
		}
		else if (!strcmp(second,"iterations"))
		{
			sscanf(third,"%d",&mc.iterations);
			
			fprintf(OUT,"\t%s\t\t%d\n",second,mc.iterations);
		}
		else if (!strcmp(second,"tosses_sq"))
		{
			sscanf(third,"%d",&mc.tosses_sq);
			
			fprintf(OUT,"\t%s\t\t%d\n",second,mc.tosses_sq);
		}
		else if (!strcmp(second,"squares_par"))
		{
			sscanf(third,"%d",&mc.squares_par);
			
			fprintf(OUT,"\t%s\t\t%d\n",second,mc.squares_par);
		}
		else if (!strcmp(second,"z_m_limit"))
		{
			scanzmlimit(third,&zlim[k].opt,zlim[k].n,&zlim[k].bk,
				&zlim[k].min,&zlim[k].max,&zlim[k].dderr); 
				
			fprintf(OUT,"\t%s\t %d %s %d %.3lf  %.3lf  %.4lf \n",second,zlim[k].opt,
								 zlim[k].n,zlim[k].bk,zlim[k].min,zlim[k].max,zlim[k].dderr);
			if (zlim[k].opt>0)
			{
				if (zlim[k].bk==0)
				{
					NPRINTF(stderr,
			"WARNING: block of unknown redshift not defined => set to 1 \n");
					zlim[k].bk=1;
				}
				k++;
			}
		}
		else if (!strcmp(second,"z_opt"))
		{
			sscanf(third,"%lf%d",&zlim[k-1].percent,&zlim[k-1].bk0);
			
			fprintf(OUT,"\t%s\t\t%.3lf%d\n",second,zlim[k-1].percent,zlim[k-1].bk0);
		}
		else if (!strcmp(second,"critic"))
		{
			sscanf(third,"%d%lf%lf%lf%lf%lf",&ii,&cl[j].C.x,&cl[j].C.y,
				&cl[j].phi,&cl[j].dl,&cl[j].z);
			
			fprintf(OUT,"\t%s\t\t%d %lf %lf  %lf  %lf  %lf\n",second,ii,
				cl[j].C.x,cl[j].C.y,cl[j].phi,cl[j].dl,cl[j].z);
			cl[j].phi*=DTR;
			if (ii>0)
			{
				cl[j].n=ii;
				j++;
			}	
		}
		else if (!strcmp(second,"adjust"))
		{
			sscanf(third,"%d%s",&I.adjust,I.Afile);
			fprintf(OUT,"\t%s\t\t%d %s\n",second,I.adjust,I.Afile);
		}
		else if (!strcmp(second,"nfilt"))
		{
			sscanf(third,"%d",&I.Anfilt);
			fprintf(OUT,"\t%s\t\t%d\n",second,I.Anfilt);
		}
		else if (!strcmp(second,"npixseeing"))
		{
			sscanf(third,"%d",&I.Anpixseeing);
			fprintf(OUT,"\t%s\t\t%d\n",second,I.Anpixseeing);
		}
		else if (!strcmp(second,"seeing"))
		{
			sscanf(third,"%lf",&I.Aseeing);
			fprintf(OUT,"\t%s\t\t%lf\n",second,I.Aseeing);
		}

		// Read the next line
		fmot(IN,second);
	}
		
	fprintf(OUT,"\t%s\n",second);
	
	I.npcl=j;
	I.nzlim=k;
}

static void scanzmlimit(char *third, int *opt, char *name, int *bk, double *min, double *max, double *prec)
{
	int i, n; // number of names
	int stop;
	char str[50], tmp[50];
	char *pch;
	
	n = 1;	// First assume only individual system
			// if n>1, n systems have the same redshift 
	stop = 0;

	// Initialize values
	*opt = *bk = *min = *max = *prec = -1;
	
	while( !stop && n <= ZMBOUND) 
	{
		strcpy( tmp, third );
		pch = strtok( tmp, " " );
		if( pch != NULL ) sscanf( pch, "%d", opt); else { stop = 1; break; }
		
		pch = strtok( NULL, " " );
		if( pch != NULL ) sscanf( pch, "%s", name ); else { stop = 1; break; }
		
		// Read additional system names
		for( i = 1 ; i < n ; i++ )
		{
			pch = strtok( NULL, " " );
			sscanf( pch, "%s", str );
			strcat( name, " " ); 
			strcat( name, str );
		}

		pch = strtok( NULL, " " );
		if( pch != NULL ) stop=sscanf( pch, "%d", bk)-1; else { stop = 1; break; }
		if( stop != 0 ) { stop = 0; n++; continue; }	// error in sscanf
	
		pch = strtok( NULL, " " );
		if( pch != NULL ) sscanf( pch, "%lf", min); else { stop = 1; break; }
	
		pch = strtok( NULL, " " );
		if( pch != NULL ) sscanf( pch, "%lf", max); else { stop = 1; break; }
		
		pch = strtok( NULL, " " );
		if( pch != NULL ) sscanf( pch, "%lf", prec); else { stop = 1; break; }
		
		pch = strtok( NULL, " " ); 
		if( pch == NULL || pch[0] == '#' )
			stop = 1;	// we found the end of the line
		else
			n++;	// there is still a parameter on the line --> 1 more name to read
	}

	if( n > ZMBOUND )
	{
		fprintf(stderr, "ERROR: Too many bounded images %s (max %d)\n",
					third, ZMBOUND);
		exit(-1);
	} else if( *prec == -1 )
	{
		fprintf(stderr, "ERROR: Missing argument in z_m_limit %s\n", third);
		exit(-1);
	}
}
