#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include<fonction.h>
#include<constant.h>
#include<dimension.h>
#include<structure.h>


static void	e_magshear(struct galaxie *arclet,double dlsds,double *ka,double *ga1,double *ga2);

/****************************************************************/
/*		nom:		s_source			*/
/*		auteur:		Jean-Paul Kneib			*/
/*		date:		10/02/92			*/
/*		place:		Toulouse			*/
/* Create a list of sources from 
 * - randomly with the tirer() function
 * - the source file M.sourfile
 * - the images file M.imafile
 * 
 * Fill the global lists <source> and <arclet> and write the sources 
 * in the file source.dat
 * 
 ****************************************************************/

void	s_source()
{
	extern struct g_mode	M;
	extern struct g_source	S;
	extern struct galaxie	arclet[NAMAX],source[NAMAX];
	extern struct pot		lens[];
	register int i;
	int	  na;
	double  ka,ga1,ga2,dlsds;
	
	NPRINTF(stderr,"SET: sources\n");
	
	if ( M.image == 0 && M.source == 0 )
		tirer(source);	/*optimisation dans le plan source*/
	else
	{
		S.ns=0;
		if (M.source!=0)
			f_shape(&S.ns,source,M.sourfile);
			
//		else if (M.source==2)
//			f_shape2(&S.ns,source,M.sourfile);	
	
		if (M.image!=0)
		{
			na=0;
//			if (abs(M.image)==1)
			f_shape(&na,arclet,M.imafile);
//			else if (abs(M.image)==2)
//				f_shape2(&na,arclet,M.imafile);

			dlsds=dratio(lens[0].z,S.zs);
			NPRINTF(stderr,"COMP: arclets shear components (DLS/DS = %lf)\n",dlsds);
			for (i=0;i<na;i++)
			{
				e_magshear(&arclet[i],dlsds,&ka,&ga1,&ga2);
				arclet[i].kappa=ka;
				arclet[i].gamma1=ga1;
				arclet[i].gamma2=ga2;
			}
	/*		ecrire_r(0,na,arclet,"aletshear.dat"); */
	
			e_unlens(na,arclet,&S.ns,source);
		}
	}
	
	pro_arclet(S.ns,source);
	
	NPRINTF(stderr,"INFO: %d sources \n", S.ns);
	ecrire_r(0,S.ns,source,"source.dat",2); // relative coordinates

}


static void	e_magshear(struct galaxie *arclet,double dlsds,double *ka,double *ga1,double *ga2)
{
	struct matrix M;

	M=e_grad2_gal(arclet);
	M.a*=dlsds;
	M.b*=dlsds;
	M.c*=dlsds;
	M.d*=dlsds;
	*ka=(M.a+M.c)/2.;
	*ga1=(M.a-M.c)/2.;
	*ga2=M.b;
}
